/*
 * Copyright (C) 2007 by basyskom GmbH
 *  @author Eva Brucherseifer <info@basyskom.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef KCALLMAINWINDOW_H
#define KCALLMAINWINDOW_H

#include <kaction.h>
#include <kapplication.h>
#include <kxmlguiwindow.h>

class KCallCore;
class DecibelDialer;
class DecibelChannelHandler;

/** KCall mainwindow in KCall application */
class KCallMainWindow : public KXmlGuiWindow
{
    Q_OBJECT

    public:
        KCallMainWindow( const QString &file = QString() );
        virtual ~KCallMainWindow();

    public slots:
        void exit();
        bool handleCommandLine();
        bool newCall(const QString& number);

    protected:
        void initActions();
        void saveProperties( KConfigGroup& );
        void readProperties( const KConfigGroup& );

        virtual bool queryClose();
        
        DecibelDialer* dialer;
        DecibelChannelHandler* channel_handler;

    private slots:
        void configureKeyBindings();
        void configureToolbars();
        void newToolbarConfig();

    private:
        KCallCore *mCore;
};

#endif
