/***************************************************************************
                          knowitchooser.cpp  -  description
                             -------------------
    begin                : pi? lut 14 2003
    copyright            : (C) 2003 by Micha? Rudolf
    email                : mrudolf@kdewebdev.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "knowitchooser.h"

#include <qcheckbox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <q3vbox.h>

#include <kcombobox.h>
#include <klocale.h>


KnowitChooser::KnowitChooser(QWidget* parent, Qt::WindowFlags flags)
   : KDialog(parent, flags)
{
   setWindowTitle(i18n("Export"));
   setButtons(Ok|Cancel);
   setDefaultButton(Ok);
   QLabel* l1;
   QLabel* l2;
   QWidget* mainWidget = new QWidget;
   QVBoxLayout* layout = new QVBoxLayout(mainWidget);
   setMainWidget(mainWidget);
   layout->addWidget(l1 = new QLabel(i18n("&Exported notes:")));
   layout->addWidget(notes = new KComboBox);
   l1->setBuddy(notes);
   notes->addItem(i18n("All"));
   notes->addItem(i18n("Current with children"));
   notes->addItem(i18n("Current only"));

   layout->addWidget(l2 = new QLabel(i18n("&Encoding:")));
   layout->addWidget(charset = new KComboBox);
   l2->setBuddy(charset);
   charset->addItem(i18n("Local (8-bit)"));
   charset->addItem(i18n("UTF-8"));

   layout->addItem(new QSpacerItem(0, 10));
   layout->addWidget(enumerate = new QCheckBox(i18n("Numbered titles")));
   layout->addWidget(toc = new QCheckBox(i18n("Table of contents")));
   layout->addWidget(rule = new QCheckBox(i18n("Rule betweeen notes")));
   layout->addWidget(style = new QCheckBox(i18n("Use editor font and colors")));
   setChoice(flags);
}

KnowitChooser::~KnowitChooser()
{
}

int KnowitChooser::getChoice() const
{
   int flags = 2 - notes->currentIndex();
   if (charset->currentIndex() == 1) flags = flags | UseUTF8;
   if (enumerate->isChecked()) flags = flags | Enumerate;
   if (toc->isChecked()) flags = flags | TOC;
   if (rule->isChecked()) flags = flags | AddRule;
   if (style->isChecked()) flags = flags | Style;
   return flags;
}

void KnowitChooser::setChoice(int flags)
{
   if (flags & SaveAll) notes->setCurrentIndex(0);
   else if (flags & SaveSubnotes) notes->setCurrentIndex(1);
   else notes->setCurrentIndex(2);
   charset->setCurrentIndex((flags & UseUTF8) != 0);
   enumerate->setChecked(flags & Enumerate);
   toc->setChecked(flags & TOC);
   rule->setChecked(flags & AddRule);
   style->setChecked(flags & Style);
}
