/***************************************************************************
                          knowitedit.cpp  -  description
                             -------------------
    begin                : pi� maj 23 2003
    copyright            : (C) 2003 by Micha� Rudolf
    email                : mrudolf@kdewebdev.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "knowitedit.h"
#include <k3urldrag.h>
#include <KDebug>

#include <QKeyEvent>

KnowitEdit::KnowitEdit(const QString& text, const QString& context, QWidget* parent,
   const char* name) : K3TextEdit(text, context, parent, name), swapEOL(true)
{
   setAcceptDrops(true);
}


KnowitEdit::KnowitEdit(QWidget* parent, const char* name) : K3TextEdit(parent, name),
   swapEOL(true)
{

}

void KnowitEdit::keyPressEvent(QKeyEvent* e)
{
#ifdef KDE4PORTING_TEMPORARILY_REMOVED
   if (swapEOL &&
          (e->key() == Qt::Key_Enter || e->key() == Qt::Key_Return) &&
          (e->state() | (Qt::NoButton |  Qt::ControlModifier | Qt::KeypadModifier) ==
             (Qt::NoButton |  Qt::ControlModifier | Qt::KeypadModifier))) {
      QKeyEvent* e1 = new QKeyEvent(QKeyEvent::KeyPress, e->key(),
         e->ascii(), e->state() ^ Qt::ControlModifier, e->text(), e->isAutoRepeat(),
         e->count());
      e->ignore();
      Q3TextEdit::keyPressEvent(e1);
      }
   else
#else
   kWarning() << "Code temporarily removed in KnowitEdit::keyPressEvent";
#endif

       Q3TextEdit::keyPressEvent(e);
}

void KnowitEdit::contentsDragEnterEvent(QDragEnterEvent* event)
{
   if (K3URLDrag::canDecode(event))
      event->accept();
   else Q3TextEdit::contentsDragEnterEvent(event);
}

void KnowitEdit::contentsDropEvent(QDropEvent* event)
{
   if (K3URLDrag::canDecode(event)) {
      KUrl::List L;
      K3URLDrag::decode(event, L);
      for (uint i=0; i<L.count(); i++)
         emit textDropped(L[i].url(), L.count() > 1);
   }
   else Q3TextEdit::contentsDropEvent(event);
}

