/*
    Copyright (C) 2008    Dmitry Ivanov <vonami@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KRSS_ABSTRACTPROXYFEED_P_H
#define KRSS_ABSTRACTPROXYFEED_P_H

#include "item.h"
#include "itemlistjob.h"
#include "tag.h"

#include <KIcon>

#include <QtCore/QString>
#include <QtCore/QList>
#include <QtCore/QHash>
#include <QtCore/QStringList>

class QTimer;

namespace KRss {

class Feed;
class Feedlist;

class AbstractProxyFeedPrivate
{
public:

    enum Status {
        Idle,
        FetchStarted,
        FetchFinished
    };

    explicit AbstractProxyFeedPrivate()
        : m_fetchTimer( 0 )
    {
    }

    QString m_title;
    QString m_description;
    QString m_type;
    KIcon m_icon;
    QList<TagId> m_tags;

    // for regular fetching
    QTimer *m_fetchTimer;

    // source feeds
    QList<Feed*> m_sourceFeeds;

    // feeds state
    QHash<Feed*, uint> m_percents;
    QHash<Feed*, Status> m_statuses;
};

} // namespace KRss

#endif // KRSS_ABSTRACTPROXYFEED_P_H
