/*
    Copyright (C) 2008    Dmitry Ivanov <vonami@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KRSS_NETFEEDCREATEJOB_H
#define KRSS_NETFEEDCREATEJOB_H

#include "krss_export.h"

#include <KJob>

namespace KRss {

class NetFeedCreateJobPrivate;

class KRSS_EXPORT NetFeedCreateJob : public KJob
{
    Q_OBJECT

public:

    enum Error {
        DBusCallQueueingFailed = KJob::UserDefinedError,
        FeedCreationFailed
    };

public:

    explicit NetFeedCreateJob( const QString &xmlUrl, const QString &subscriptionLabel,
                               const QString &resourceIdentifier, QObject *parent = 0 );
    ~NetFeedCreateJob();

    void start();
    QString errorString() const;

private Q_SLOTS:

    void doStart();
    void slotCallFinished( qlonglong id );
    void slotCallFailed();

private:

    NetFeedCreateJobPrivate * const d;
};

} // namespace KRss

#endif // KRSS_NETFEEDCREATEJOB_H
