/*
    Copyright (C) 2008    Dmitry Ivanov <vonami@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "feedlistview.h"
#include "feedlistmodel.h"

#include <QMetaType>
#include <KDebug>

using namespace KRss;

FeedListView::FeedListView( QWidget *parent )
    : QTreeView( parent )
{
    setSelectionBehavior( QAbstractItemView::SelectRows );
    connect( this, SIGNAL( clicked( const QModelIndex& ) ),
             this, SLOT( slotClicked( const QModelIndex&) ) );
    connect( this, SIGNAL( activated( const QModelIndex& ) ),
             this, SLOT( slotActivated( const QModelIndex&) ) );
}

FeedListView::~FeedListView()
{
}

Feed* FeedListView::currentFeed() const
{
    return model()->data( currentIndex(), FeedListModel::FeedRole ).value<Feed*>();
}

void FeedListView::slotClicked( const QModelIndex &index )
{
    emit clicked( model()->data( index, FeedListModel::FeedRole ).value<Feed*>() );
}

void FeedListView::slotActivated( const QModelIndex &index )
{
    emit clicked( model()->data( index, FeedListModel::FeedRole ).value<Feed*>() );
}

#include "feedlistview.moc"
