/*
    Copyright (C) 2008    Dmitry Ivanov <vonami@gmail.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef KRSS_ADDFEEDJOB_H
#define KRSS_ADDFEEDJOB_H

#include "libkrss/feedcollection.h"

#include <syndication/syndication.h>
#include <KJob>

#include <QDBusMessage>

class AddFeedJob : public KJob
{
        Q_OBJECT

public:
        enum Error {
                CollectionCreationFailed = KJob::UserDefinedError
        };

public:

        explicit AddFeedJob( const KRss::FeedCollection &feed, QObject *parent = 0 );
        ~AddFeedJob();

        void setReplyMessage( const QDBusMessage &message );
        QDBusMessage replyMessage() const;
        KRss::FeedCollection feed() const;

        void start();
        QString errorString() const;

private Q_SLOTS:

        void doStart();
        void fetchDone( Syndication::Loader *loader, Syndication::FeedPtr feedptr, Syndication::ErrorCode status );
        void collectionCreationDone( KJob *job );

private:

        KRss::FeedCollection m_feed;
        int m_fetchTries;
        QDBusMessage m_replyMessage;
};

#endif /* KRSS_ADDFEEDJOB_H */
